package com.fasga.rs.bot.deobfuscate;

import java.util.List;

import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.MethodNode;
import org.objectweb.asm.tree.TryCatchBlockNode;

public class ExceptionScrubber extends Deobfuscator {
	@Override
	public boolean applyDeobfuscation(ClassNode node) {
		for(MethodNode method : (List<MethodNode>) node.methods) {
			for(int i = 0; i < method.tryCatchBlocks.size(); i++) {
				TryCatchBlockNode block = (TryCatchBlockNode) method.tryCatchBlocks.get(i);
				if(block.type != null && block.type.equals("java/lang/RuntimeException")) {
					method.tryCatchBlocks.remove(block);
				}
			}
		}
		return true;
	}
}
