package com.fasga.rs.bot.util;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.tree.ClassNode;

public class JARAdapter {
	public ClassNode[] loadClasses(String jarName) {
		try {
			LinkedList<ClassNode> classes = new LinkedList<ClassNode>();
			JarFile file = new JarFile(jarName);
			Enumeration<JarEntry> entries = file.entries();
			while(entries.hasMoreElements()) {
				JarEntry entry = entries.nextElement();
				if(entry.getName().endsWith(".class")) {
					InputStream is = file.getInputStream(entry);
					ClassReader reader = new ClassReader(is);
					ClassNode node = new ClassNode();
					reader.accept(node, 0);
					classes.add(node);
				}
			}
			return classes.toArray(new ClassNode[0]);
		} catch(IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public void dumpClasses(String jarName, ClassNode[] classes) {
		try {
			File file = new File(jarName);
			JarOutputStream out = new JarOutputStream(new FileOutputStream(file));
			for(ClassNode node : classes) {
				JarEntry entry = new JarEntry(node.name + ".class");
				out.putNextEntry(entry);
				ClassWriter writer = new ClassWriter(ClassWriter.COMPUTE_MAXS);
				node.accept(writer);
				out.write(writer.toByteArray());
			}
			out.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
}
