package com.fasga.rs.bot.util;

import java.util.List;

import org.objectweb.asm.Opcodes;
import org.objectweb.asm.Type;
import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.FieldNode;
import org.objectweb.asm.tree.MethodNode;

public class TransformerHelper implements Opcodes {
	public static void addInterface(ClassNode node, String name) {
		System.out.println("\t^ " + node.name + " implements " + name);
		node.interfaces.add(name);
	}
	
	public static void addGetter(ClassNode node, FieldNode field, String name, String desc) {
		System.out.println("\t* " + name + "() gets field " + node.name + "." + field.name);
		MethodNode method = new MethodNode(ACC_PUBLIC, name, "()" + desc, null, null);
		method.visitVarInsn(ALOAD, 0);
		method.visitFieldInsn(GETFIELD, node.name, field.name, field.desc);
		method.visitInsn(Type.getType(field.desc).getOpcode(IRETURN));
		method.visitMaxs(0, 0);
		node.methods.add(method);
	}
	
	public static FieldNode getFieldByName(ClassNode node, String name) {
		for(FieldNode field : (List<FieldNode>) node.fields) {
			if(field.name.equals(name)) {
				return field;
			}
		}
		return null;
	}
}
